<?php
/*
  Plugin Name: chatgpt-auto-article
  Plugin URI:
  Description: chatGPTで記事を量産する
  Version: 1.0.0
  Author: @toshiaki_taoka
  Author URI: https://twitter.com/toshiaki_taoka
 */

if (!defined('ABSPATH')) exit;
require "common/post-chatgpt.php";

add_action('admin_init', 'save_chatgpt_auto_article');
add_action('admin_menu', 'chatgpt_auto_article_menu');

function chatgpt_auto_article_menu()
{
    add_menu_page(
        'chatGPTで記事を量産する', // ページのタイトル
        'chatgpt-AutoArticle', // メニューのタイトル
        'manage_options', // 必要な権限
        'chatgpt-auto-article', // ページの識別子
        'chatgpt_auto_article_page', // ページのコールバック関数
    );
}

function save_chatgpt_auto_article()
{
    register_setting('chatgpt-auto-article-group', 'chatgpt-auto-article-group-api-key');
}

function chatgpt_auto_article_page()
{
    $chatgptApiKey = get_option("chatgpt-auto-article-group-api-key") ?: "";
?>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" crossorigin="anonymous">
    <div class="container">
        <div class="row">
            <form action="options.php" method="post">
                <?php
                settings_fields('chatgpt-auto-article-group');
                do_settings_sections('chatgpt-auto-article-group');
                ?>
                <div class="col-12">
                    chatGPT_APIKEY:
                </div>
                <div class="col-12">
                    <input class="form-control" type="password" name="chatgpt-auto-article-group-api-key" value="<?= esc_attr($chatgptApiKey) ?>">
                </div>
                <?php submit_button(); ?>
            </form>
            <?php
            $i = 0;
            $datatime = new DateTime('Asia/Tokyo');
            while ($i < 7) {
                $i++;
            ?>
                <div class="col-12">
                    <span class="reslut"></span><br>
                    タイトル／投稿日時:
                </div>
                <div class="input-group mb-3">
                    <input class="form-control" type="text" name="title[]" value="" required>
                    <input class="input-group-text form-control" type="datetime-local" name="date[]" value="<?= $datatime->format('Y-m-d H:i:s') ?>" required>
                </div>                
                <div class="col-12">
                    生成させたい記事に対してのキーワード:
                </div>
                <div class="col-12">
                    <input class="form-control" type="text" name="keyword[]" value="" required>
                </div>
                <hr class="m-3">
            <?php
                $datatime->modify('+1 days');
            }
            ?>
            <button class="btn btn-success btn-lg " id="make" type="button" role="button">記事を量産する</button>
        </div>
    </div>
    <script>
        function makeArticle() {
            document.querySelectorAll(".reslut").forEach(el => {
                el.innerHTML = "";
            });
            document.querySelectorAll("[name^=keyword]").forEach((el, keynum) => {
                let formData = new FormData();
                formData.append('title', document.querySelectorAll("[name^=title]")[keynum].value);
                formData.append('keyword', document.querySelectorAll("[name^=keyword]")[keynum].value);
                formData.append('datetime', document.querySelectorAll("[name^=date]")[keynum].value);
                document.querySelectorAll(".reslut")[keynum].innerHTML = "■ 処理中 ■";
                let init = {
                    method: 'POST',
                    body: formData,
                };
                fetch("https://<?= $_SERVER['SERVER_NAME'] ?>/wp-admin/admin-ajax.php?action=chatgpt_auto_article_wppost_action", init).then(response => response.json()).then(data => {
                    if (data.res === "OK") {
                        document.querySelectorAll(".reslut")[keynum].innerHTML = "■ 完了 ■";
                    } else {
                        document.querySelectorAll(".reslut")[keynum].innerHTML = "■ 失敗 ■";
                    }
                });
            });
        }
        document.getElementById("make").addEventListener("click", makeArticle);
    </script>
<?php

}

add_action('wp_ajax_chatgpt_auto_article_wppost_action', 'chatgpt_auto_article_wppost_ajax_handler');
add_action('wp_ajax_nopriv_chatgpt_auto_article_wppost_action', 'chatgpt_auto_article_wppost_ajax_handler');
